#ifndef TimerTask_h
#define	TimerTask_h

class TimerTaskScheduler;
class TimerTaskEntry;

class TimerTask {
    friend class TimerTaskScheduler;
    friend class TimerTaskEntry;
    
public:
    TimerTask();
    
    virtual ~TimerTask() {};
    
    virtual void timerExecute() = 0;
    virtual bool isTerminated();
    
    void terminate();

private:
    long getTaskId();
    void setTaskId(long id);
    
    bool terminated;
    long taskId;
};

#endif
